<template>
  <v-dialog v-model="dialog" max-width="500">
    <v-card>
      <v-card-title class="headline">Create Group</v-card-title>

      <v-card-text>
        <v-form v-model="valid">
          <v-list>
            <v-text-field label="Name" v-model="name"/>
          </v-list>
        </v-form>
      </v-card-text>

      <v-card-actions>
        <v-spacer></v-spacer>

        <v-btn color="red darken-1" flat="flat" @click="dialog = false" :loading="loading">Cancel</v-btn>
        <v-btn
          color="green darken-1"
          flat="flat"
          @click="createGroup(); dialog = false"
          :loading="loading"
        >Agree</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
import gql from "graphql-tag";

export default {
  props: {
    id: String
  },
  data() {
    return {
      valid: null,
      dialog: false,
      loading: false,
      group: {
        name: ""
      }
    };
  },
  computed: {
    name: {
      get() {
        return this.group && this.group.name;
      },
      set(v) {
        this.group.name = v;
      }
    }
  },
  methods: {
    open() {
      this.dialog = true;
    },
    async createGroup() {
      this.loading = true;

      try {
        await this.$apollo.mutate({
          mutation: gql`
            mutation($group: ProductGroupInputCreate!) {
              productGroupCreate(group: $group) {
                id
              }
            }
          `,
          variables: {
            group: this.group
          }
        });
      } catch (e) {
        console.error(e);
      } finally {
        this.loading = false;
      }
    }
  }
};
</script>
